/*
*   
* Sockets && fork() && signal
* Servidor que recibe peticiones a traves de sockets tcp
* y realiza spwan de procesos pesados por cada cliente a
* atender
*
*
*
*
* UTN FRD 
* SO 2009
* Guillermo Cherencio
*/
#include <stdio.h>
#include <stdlib.h>
#include "srvp.h"

/*************************************************************************************************
   F U N C I O N E S      
**************************************************************************************************/

int server() {
   int i,x,adrl;
   size_t size;

   srvpdata data;
   srvp = &data;
   data.fp = fopen("srvp.log","w");
   if ( data.fp == NULL ) {
      fprintf(stderr,"main():Error en apertura de srvp.log\n");
      return -10;
   }
   fprintf(data.fp,"main():inicio\n");

   // signals
   if ( signal(SIGQUIT,sig_salir) == SIG_ERR ) { // CTRL+backslash
      fprintf(stderr,"main():Error capturando seal SIGQUIT\n");
   }   
   if ( signal(SIGINT,sig_salir) == SIG_ERR ) { // CTRL+C o Del
      fprintf(stderr,"main():Error capturando seal SIGINT\n");
   }   

   // inicializo data
   data.salir=0;
   // inicializo buffer de recepcion
   msg *p = &data.buffer[0];
   memset(p,0,FD_SETSIZE*512);
   memset(&data.ip[0],0,FD_SETSIZE*25);

   printf("main():Intento Abrir socket server\n");
   data.serversocket = socket(AF_INET, SOCK_STREAM, 0);
   if (data.serversocket < 0) { 
      fprintf(stderr,"main():Error,No se puede crear socket\n");
      return -1;
   }
   printf("main():Socket server abierto\n");

   data.serverport = 7777;
   bzero(&data.server, sizeof(struct sockaddr_in));
   data.server.sin_family = AF_INET;
   data.server.sin_addr.s_addr = INADDR_ANY;
   data.server.sin_port = htons(data.serverport);

   printf("main():Intento hacer bind de socket\n");
   x = bind(data.serversocket, (struct  sockaddr *) &data.server, sizeof(data.server));
   if (x<0) {
      close(data.serversocket); 
      fprintf(stderr,"main():Error,No se puede hacer bind de socket\n");
      return -2;
   }
   printf("main():Socket server binded\n");

   printf("main():Intento hacer listen de socket\n");
   if (listen(data.serversocket, 10) < 0) {
      close(data.serversocket);
      fprintf(stderr,"main():Error, No se puede hacer listen en socket server\n");
      return -3;
   }
   printf("main():Socket listening\n");

   /* Initialize the set of active sockets. */
   printf("main():Inicializo Socket Set\n");
   FD_ZERO (&data.active_fd_set);
   FD_SET  (data.serversocket, &data.active_fd_set);

   adrl = sizeof(struct sockaddr_in);
   fprintf(stdout,"main():Servidor activo en puerto %d\n",data.serverport);
   printf("main():Server esperando peticiones de clientes\n");
   while(!data.salir) {
      /* Block until input arrives on one or more active sockets. */
      data.read_fd_set = data.active_fd_set;
      if (select (FD_SETSIZE, &data.read_fd_set, NULL, NULL, NULL) < 0) {
         fprintf(stderr,"main():Error en select() bloqueando sockets!\n");
         data.salir=1;
         continue;
      }
      /* Service all the sockets with input pending. */
      for (i = 0; i < FD_SETSIZE; ++i) {
         if (FD_ISSET (i, &data.read_fd_set)) {
            if (i == data.serversocket) {
               /* Connection request on original socket. */
               int new;
               size = sizeof(data.clientname);
               new = accept(data.serversocket,(struct sockaddr *) &data.clientname,&size);
               if (new < 0) {
                  fprintf(stderr,"main():Error en accept()\n");
                  data.salir=1;
                  continue;
               }
               fprintf (stderr,"Server: connect from host %s, port %hd. socket %d\n",
                        inet_ntoa(data.clientname.sin_addr),
                        ntohs(data.clientname.sin_port),new);
               inet_ntop(AF_INET,&data.clientname.sin_addr,data.ip[new],25); // ip del cliente
               FD_SET(new, &data.active_fd_set);
            } else {
               /* Data arriving on an already-connected socket. */
               msg *p = &data.buffer[i];
               memset(p,0,sizeof(msg));
               //int nbytes = read(i,&data.buffer[i],sizeof(msg));
               read(i,p,sizeof(msg));
               //if ( nbytes >= 512 ) fprintf(stderr,"main():Se superaron los 512 bytes de recepcion!\n");
               //close(i);
               // spawn
               data.salir = (strcmp(data.buffer[i].comando,"SHT") == 0);
               int cerrar = (data.salir || strcmp(data.buffer[i].comando,"END") == 0);
               spawn(i,&data);
               strcpy(data.buffer[i].comando,"OK");
               write(i,p,sizeof(msg));
               if (cerrar) {
                  close(i);
                  FD_CLR(i,&data.active_fd_set);
               }
            }
         }
      }
   }
   printf("main():fin\n");
   fprintf(data.fp,"main():fin\n");
   fclose(data.fp);
   return 0;
}

void sig_salir(int signo) {
   srvp->salir=1;
   printf("sig_salir(): Estoy saliendo de servidor!\n");
   if ( signal(SIGQUIT,SIG_DFL) == SIG_ERR ) {
      fprintf(stderr,"sig_salir(): No puedo resetear SIGQUIT\n");
   }
   if ( signal(SIGINT,SIG_DFL) == SIG_ERR ) {
      fprintf(stderr,"sig_salir(): No puedo resetear SIGINT\n");
   }
   printf("sig_salir():Servidor Apagado!\n");
   fprintf(srvp->fp,"sig_salir():fin\n");
}

void spawn(int i,srvpdata *srv) {
   msg m;
   msg *p = &srv->buffer[i];
   memcpy(&m,p,sizeof(msg));
   fprintf(srv->fp,"spawn(): usr: [%s] msg: [%s] ip:[%s] cmd:[%s]\n",m.usuario,m.mensaje,srv->ip[i],m.comando);
   // ejecutar programa
}


